<?php
/*
Plugin Name: 19s: View Counter
Plugin URI: https://19stopni.pl
Description: Wtyczka zlicza wyświetlenia danej podstrony i wyświetla liczbę za pomocą shortcode.
Version: 1.0
Author: N04H
Author URI: https://19stopni.pl
*/

function enqueue_ajax_script() {
    wp_enqueue_script('ajax-view-counter', plugin_dir_url(__FILE__) . 'js/ajax-view-counter.js', array('jquery'), null, true);
    wp_localize_script('ajax-view-counter', 'post_data', array(
        'ajax_url' => admin_url('admin-ajax.php'),
        'nonce' => wp_create_nonce('ajax-nonce'),
        'post_id' => get_the_ID()
    ));
}
add_action('wp_enqueue_scripts', 'enqueue_ajax_script');

function ajax_count_page_views() {
    check_ajax_referer('ajax-nonce', 'security');
    $post_id = isset($_POST['post_id']) ? intval($_POST['post_id']) : 0;

    if($post_id > 0) {
        $current_views = get_post_meta($post_id, 'views', true);
        $current_views = (!empty($current_views)) ? $current_views : 0;
        $current_views++;
        update_post_meta($post_id, 'views', $current_views);
        
        echo $current_views;
    }
    wp_die();
}
add_action('wp_ajax_nopriv_count_views', 'ajax_count_page_views');
add_action('wp_ajax_count_views', 'ajax_count_page_views');

function show_views() {
    global $post;
    $views = get_post_meta($post->ID, 'views', true);
    if(!isset($views) OR empty($views)) {
        return "0 wyświetleń";
    }
    $last_digit = $views % 10;
    $last_two_digits = $views % 100;
    if($views == 1) {
        $text = 'wyświetlenie';
    } elseif(($last_digit >= 2 && $last_digit <= 4) && !($last_two_digits >= 12 && $last_two_digits <= 14)) {
        $text = 'wyświetlenia';
    } else {
        $text = 'wyświetleń';
    }
    return $views.' '.$text;
}
add_shortcode('show_views', 'show_views');

function add_views_meta_box() {
    add_meta_box('post_views', 'Liczba wyświetleń', 'views_meta_box_callback', 'post', 'side', 'high');
}
add_action('add_meta_boxes', 'add_views_meta_box');

function views_meta_box_callback($post) {
    wp_nonce_field('save_views_meta', 'views_meta_box_nonce');
    $views = get_post_meta($post->ID, 'views', true);
    echo '<label for="post_views_field">Liczba wyświetleń:</label>';
    echo '<input type="number" id="post_views_field" name="post_views_field" value="' . esc_attr($views) . '" />';
}

function save_views_meta_box_data($post_id) {
    if (!isset($_POST['views_meta_box_nonce']) || !wp_verify_nonce($_POST['views_meta_box_nonce'], 'save_views_meta')) {
        return;
    }

    if (defined('DOING_AUTOSAVE') && DOING_AUTOSAVE) {
        return;
    }

    if (isset($_POST['post_views_field']) && is_numeric($_POST['post_views_field'])) {
        update_post_meta($post_id, 'views', $_POST['post_views_field']);
    }
}
add_action('save_post', 'save_views_meta_box_data');